#include <windows.h>
#include "AudioSpec.h"
#include "AudioCode.h"
#include "audiohle.h"
#include "../audioinfo.h"

// Dialogs

// Initialization / Deinitalization Functions

// Note: We call CloseDLL just in case the audio plugin was already initialized...
AUDIO_INFO AudioInfo;
AudioCode  snd;
DWORD Dacrate = 0;
void AiCallBack (DWORD Status);

EXPORT BOOL CALL InitiateAudio (AUDIO_INFO Audio_Info){
	AiCloseDLL ();
	memcpy (&AudioInfo, &Audio_Info, sizeof(AUDIO_INFO));
	snd.Initialize (AiCallBack, AudioInfo.hwnd);
	return TRUE;
}

EXPORT void CALL AiCloseDLL (void){
	ChangeABI (0);
	snd.DeInitialize ();
}

EXPORT void CALL AiGetDllInfo ( PLUGIN_INFO * PluginInfo ){
	PluginInfo->MemoryBswaped = TRUE;
	PluginInfo->NormalMemory  = FALSE;
	//strcpy (PluginInfo->Name, "Azimer's HLE Audio v");
	//strcat (PluginInfo->Name, PLUGIN_VERSION);
	PluginInfo->Type = PLUGIN_TYPE_AUDIO;
	PluginInfo->Version = 0x0101; // Set this to retain backwards compatibility
}

EXPORT void CALL ProcessAList(void){
	// sync game to audio
	//while (snd.playing() && snd.GetremainingBytes()+LOCK_SIZE > MAXBUFFER) {
	//	Sleep(1);
	//}
	while (snd.mod->IsPaused()) {Sleep(50);}
	if (!IsSeeking()) {
		HLEStart ();
	}
}

EXPORT void CALL AiRomClosed (void){
	ChangeABI (0);
	snd.StopAudio ();
	Dacrate = 0;
	//snd.Initialize(AiCallBack, AudioInfo.hwnd);
}

EXPORT void CALL AiDacrateChanged (int  SystemType) {
	DWORD Frequency;
	if (Dacrate != *AudioInfo.AI_DACRATE_REG) {
		Dacrate = *AudioInfo.AI_DACRATE_REG;
		switch (SystemType) {
			case SYSTEM_NTSC: Frequency = 48681812 / (Dacrate + 1); break;
			case SYSTEM_PAL:  Frequency = 49656530 / (Dacrate + 1); break;
			case SYSTEM_MPAL: Frequency = 48628316 / (Dacrate + 1); break;
		}
		snd.SetFrequency (Frequency);
	}
}

EXPORT void CALL AiLenChanged (void){
	DWORD retVal;
	retVal = snd.AddBuffer (
		(AudioInfo.RDRAM + (*AudioInfo.AI_DRAM_ADDR_REG & 0x00FFFFF8)), 
		*AudioInfo.AI_LEN_REG & 0x3FFF8);
	//if (retVal & SND_IS_FULL)
	//	*AudioInfo.AI_STATUS_REG |= AI_STATUS_FIFO_FULL;
	//*AudioInfo.AI_STATUS_REG |= AI_STATUS_DMA_BUSY;
}

EXPORT DWORD CALL AiReadLength (void){
	*AudioInfo.AI_LEN_REG = snd.GetReadStatus ();

	//*AudioInfo.MI_INTR_REG |= MI_INTR_AI;
	//AudioInfo.CheckInterrupts();

	return *AudioInfo.AI_LEN_REG;
}

EXPORT DWORD CALL IsSeeking(void) {
	if (FastSeek && snd.time < snd.seektime) return 1;
	return 0;
}

EXPORT DWORD CALL PlayTime() {
	double t;
	if (IsFreqSet() && (t=snd.time+(AudioInfo.mod->outMod->GetOutputTime()-AudioInfo.mod->outMod->GetWrittenTime()))>0) return (unsigned long)t;
	else return 0;
}

EXPORT void CALL SeekTo(int seek_dest) {
	snd.seektime=seek_dest;
}